# Distro

Commands with marked are only to be run on those system. Unmarked commands should be run on all systems. Not that Ubuntu 16.04 64bit is the base working platform.
	Ubunutu: Marked as "UB".
	ArchLinux: Marked as "AL". Note that "pip" will need to be "pip3".

	OSX: Marked as "OSX". Install "brew" first.
	
## Packages

source-packages are stored in the mortoray.com launchpad project.
	
## Leaf

### GCC
	
gcc 5.3.1 or newer should work. Some C++14 features are being used, thus older versions will not likely work.
		
	UB> apt-get install g++ make bzr scons
	AL> pacman -S gcc make bzr scons
	OSX> brew install gcc bzr scons
		
### Pip
	
The test suite uses python. They were written in Python3, along with the shelljob library.
	
	UB> apt-get install libyaml-dev
	AL> pacman -S python2 python2-pip

	> pip install shelljob pyyaml
	AL2> pip3 install shelljob pyyaml
	
	? OSX> brew install python libyaml
	? OSX> pip3 install pypandoc shelljob pyyaml
		
### LLVM
	
	UB> apt-get install graphviz libffi-dev
	AL> pacman -S graphviz doxygen
		
	> pip install sphinx
	OSX> pip3 install sphinx

Standard builds won't work, you need a custom build. You can use a different `INSTALL_PREFIX` just make a note of it for the scons setup.
Version: 3.8.0
		
	mkdir build
	cd build
	cmake .. -DCMAKE_BUILD_TYPE=Release -DLLVM_ENABLE_EH=ON -DLLVM_ENABLE_RTTI=ON -DLLVM_REQUIRES_RTTI=ON -DLLVM_ENABLE_CXX1Y=ON -DLLVM_LINK_LLVM_DYLIB=ON -DLLVM_ENABLE_FFI=ON -DLLVM_ENABLE_ASSERTIONS=ON -DLLVM_OPTIMIZED_TABLEGEN=ON -DCMAKE_INSTALL_PREFIX="/opt/llvm/install"
	make -j7
	make install

### GMP
	
	UB> apt-get install m4 libgmp
	AL> pacman -S m4 ?libgmp?
	OSX> brew install gmp
			
### Boost
	
	UB> apt-get install libboost-regex-dev libboost-filesystem-dev
	AL> pacman -S boost
	OSX> brew install boost
		
		
## Build

Accepting all default arguments, in the root directory of the project simply type:

	scons -D LLVM_DIR=/opt/llvm/install

	Example for OSX>
		scons -D LLVM_DIR=~/src-leaf/llvm/install -D BOOST_PREFIX=/usr/local/Cellar/boost/1.63.0/ -D GMP_DIR=/usr/local/Cellar/gmp/6.1.2/
		
Subsequent builds can just do:

	scons

	If you have installed libraries in a different location  or wish to see the other build options try:
		scons --help

### Tests
	
To run all the automated tests:

	scons check

### Running

To setup the environment for running the binaries directly source the env.sh file.

	source build/env.sh
		
As an example this runs the fibonnacci test program:

	build/leaf --unit-test share/tests/full/fib.leaf

Use the "--help" option on parse for a list of all its options (which include outputting various form trees).
