#ifndef LEAF_IR_FWD_HPP
#define LEAF_IR_FWD_HPP

#include "../core_types.hpp"

namespace ir
{
	enum class block_flow {
		sequential,
		defer,
		defer_fail
	};

	class compiler;
	class type_manager;
	struct compiler_context;
	
	struct module;
	class function;
	struct type;
	class block;
	struct block_seq_item;
	struct value;

	struct instruction;
	
	struct acquire_shared_inst;
	struct alloc_array_inst;
	struct alloc_shared_inst;
	struct array_offset_inst;
	struct array_ptr_offset_inst;
	struct binary_inst;
	struct bind_func_inst;
	struct bind_func_explicit_inst;
	struct bind_raw_func_inst;
	struct cast_inst;
	struct clone_inst;
	struct comment_inst;
	struct fail_inst;
	struct free_array_inst;
	struct funccall_inst;
	struct loop_flow_inst;
	struct loop_inst;
	struct loss_inst;
	struct malloc_inst;
	struct pack_tuple_inst;
	struct promote_inst;
	struct promote_loss_inst;
	struct release_shared_inst;
	struct resolve_inst;
	struct resume_inst;
	struct return_inst;
	struct special_field_inst;
	struct store_inst;
	struct struct_pointer_inst;
	struct switch_inst;	
	struct unary_inst;
	struct void_context_inst;
	
	struct shared_object_defn;
	
	//leaf specific parts
	class compiler_leaf;
	class type_manager_leaf;

} //eon ir

namespace util {
	struct validation_context;
}
#include "value.hpp"

#endif