#ifndef LEAF_IR_LLVM_RUNTIME_TEST_HPP
#define LEAF_IR_LLVM_RUNTIME_TEST_HPP

#include "core_types.hpp"

#include <setjmp.h>

namespace runtime_test {

/**
	Setup the runtime execution environment.
	
	@param abort_point where an abort call should longjmp. Prior to longjmp an error string
		will be set, obtainable with get_error. Note that not all resources will be cleaned in the
		case of an abort/longjmp.
*/
void prepare( jmp_buf * abort_point );

std::string get_trace();
std::string get_error();

/**
	Do post-checking of the runtime state. This can detect additional problems, such as
	unfreed memory.
*/
void check_state();

}

#endif