#ifndef LEAF_IR_MODULE_HPP
#define LEAF_IR_MODULE_HPP

#include "fwd.hpp"

#include <string>
#include <map>

namespace ir
{

struct module
{
	module( std::string const & name, compiler_context & cctx );
	compiler_context & cctx;
	
	std::string name;
	
	shared_ptr<function> create_function( std::string const & name, 
		shared_ptr<value> use_value = shared_ptr<value>() );
	shared_ptr<function> if_get_function( std::string const & name ) const;
	
	typedef std::map<std::string, shared_ptr<function>> function_map_t;
	function_map_t function_map;
	
	typedef std::map<std::string, shared_ptr<value>> global_variable_map_t;
	global_variable_map_t global_variable_map;
	
	shared_ptr<value> if_get_global_variable( std::string const & name );
	void register_global( shared_ptr<value> g );

	typedef std::map<std::string, shared_ptr<type>> named_types_t;
	named_types_t named_types;
	
	void validate( util::validation_context & vctx) const;
};

} //eon ir
#endif