#ifndef LEAF_IR_STD_FUNCTIONS_HPP
#define LEAF_IR_STD_FUNCTIONS_HPP

#include "compiler_context.hpp"

namespace ir 
{

struct builder;

value_defn get_delete_array_func( compiler_context & cc, shared_ptr<ir::type const> item_type );
value_defn get_new_func( compiler_context & cc, shared_ptr<ir::type const> array_type );
value_defn get_array_copy_func( compiler_context & cc, shared_ptr<ir::type const> item_type );

/**
	Produces a function wit the signature
		( obj : raw_ptr<type> ) -> ()
	This function does a full release on the type (including all parts).
*/
value_defn get_release_function( compiler_context & cc, shared_ptr<type const> rt );

}

#endif