#ifndef LEAF_ASSIGN_STATEMENT_HPP
#define LEAF_ASSIGN_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

struct expression;

struct assign_statement : public statement
{
	typedef statement super;
	
	virtual statement_form_t statement_form() const { 
		return sf_assign_statement; 
	}

	//statement initializes refered value of reference
	enum how_t {
		h_value,
		h_init_refer,
		h_default,
	} how;
	
	shared_ptr<expression> left, right;
	
	assign_statement() { 
		how = h_value;
	}
	
	STATEMENT_PRE_CLONE(assign_statement);
	STATEMENT_SERIAL()
protected:
	void pre_copy( assign_statement const & o );
	
	void write_impl( serial_out & so ) const;
	void read_impl( serial_in & so );
};

} //eon leaf
#endif