#ifndef LANG_CLASS_TYPER_HPP
#define LANG_CLASS_TYPER_HPP

#include "typer.hpp"

namespace leaf
{

class class_typer : public job {
	shared_ptr<typedef_statement> source_ts;
	context decl_context, class_context;
	shared_ptr<intr_type_classlike> class_type;
	
	class_typer( context decl_context, shared_ptr<intr_type_classlike> class_type );
public:
	
	static void process( shared_ptr<typedef_statement> ts, context decl_context );
	static void instantiate( shared_ptr<intr_type_classlike> class_type, context proc_context );
	
	bool process( typer * ty );
	
private:
	bool class_block_done;
	
	bool has_dtor;
	shared_ptr<expr_funcdefn> build_dtor();
	
	bool is_ctor_complete, ctor_require_import;
	void build_ctors();
	shared_ptr<expr_funcdefn> build_implicit_ctor(bool is_default);
	bool complete_ctors();
	
	std::vector<shared_ptr<expr_funcdefn>> ctor_funcs;
};

} //eon leaf

#endif