#ifndef LANG_CONVERSION_APPLICATOR_HPP
#define LANG_CONVERSION_APPLICATOR_HPP

#include "../core_types.hpp"
#include "fwd.hpp"
#include "type_converter.hpp"

namespace leaf
{

/**
	Applies a conversion to an expression.
*/
class conversion_applicator
{
	context const & ctx;
public:
	conversion_applicator( context const & ctx ) :
		ctx(ctx) {
	}
	
	shared_ptr<expression> apply( type_converter::convert_t const & cost, shared_ptr<expression> expr );
	shared_ptr<expression> apply( cvt_expression & cvt, shared_ptr<expression> expr );
	shared_ptr<expression> create_shared( shared_ptr<expression> expr, bool shallow = true );
	shared_ptr<expression> drop_lvalue( shared_ptr<expression> expr );
	shared_ptr<expression> deref_optional( shared_ptr<expression> expr );
	shared_ptr<expression> apply_single( cvt_expression & cvt, shared_ptr<expression> expr );
	
	#define CVT_EXPRESSION_FORM(cvt) \
		shared_ptr<expression> apply_##cvt( cvt_expression & cvt, shared_ptr<expression> expr );
	CVT_EXPRESSION_FORMS
	#undef CVT_EXPRESSION_FORM
};

} //eon leaf

#endif