#ifndef LEAF_ERROR_STATEMENT_HPP
#define LEAF_ERROR_STATEMENT_HPP

#include "statement.hpp"

namespace leaf {

struct error_block {
	//on error handling
	fail_level on_match;
	shared_ptr<statement_block> on_error; //null if none set (TODO: rename block)
	shared_ptr<declaration> error_info; //null if not an error (as in `defer`)
};

struct error_statement : public statement {
	typedef statement super;
	
	error_statement() {
		safe_skip = false;
	}
	
	virtual statement_form_t statement_form() const override {
		return sf_error_statement;
	}
	virtual int get_flow() const override;
	
	shared_ptr<statement> inner;
	
	//the inner can be skipped even if it reports otherwise, this is for "trap" blocks
	bool safe_skip;
	
	error_block error;
protected:
	void pre_copy( error_statement const & o );
	
	void write_impl( serial_out & so ) const;
	void read_impl( serial_in & so );
};

}

#endif