#ifndef LANG_EXPRESSION_VISITOR_HPP
#define LANG_EXPRESSION_VISITOR_HPP

#include "expression.hpp"

namespace leaf
{

/**
	This is a transforming visitor of an expression. Return values from the apply methods will
	replace the caller's reference.
*/
struct expression_transformer
{
	/**	
 		@param no_default_pass if false the default apply will simply return the input, if true
 			it will throw
	*/
	expression_transformer( bool no_default_pass );
	
	shared_ptr<expression> apply_expression( shared_ptr<expression> in );
	
	bool get_no_default_pass() const
	{ return no_default_pass; }
protected:
	bool no_default_pass;
	#define EXPRESSION_FORM(form) \
		virtual shared_ptr<expression> apply_##form( shared_ptr<expr_##form> in );
	EXPRESSION_FORMS
	#undef EXPRESSION_FORM
};

} //eon leaf
#endif