#ifndef LEAF_FWD_HPP
#define LEAF_FWD_HPP

#include "core_types.hpp"
#include "util/source_location.hpp"

namespace leaf
{

struct assign_statement;
struct defer_statement;
struct do_statement;
struct error_block;
struct error_statement;
struct expression_statement;
struct fail_statement;
struct for_statement;
struct import_statement;
struct init_statement;
struct loop_flow_statement;
struct noop_statement;
struct return_statement;
struct statement;
struct typedef_statement;
struct var_statement;

struct expr_binary;
struct expr_bind;
struct expr_block;
struct expr_compound;
struct expr_conditional;
struct expr_current;
struct expr_literal_number;
struct expression;
struct expr_field;
struct expr_funccall;
struct expr_funcdefn;
struct expr_new_func;
struct expr_special_field;
struct expr_text;
struct expr_subscript;
struct expr_switch;
struct expr_symbol;
struct expr_tag;
struct expr_temp;
struct expr_transform;
struct expr_unary;
struct expr_value_list;
struct expr_with_block;
struct expr_with_sub;

struct context;
class scope;
struct statement_block;
struct type_ref;
struct extr_type;
struct variable;
struct type_spec;
struct declaration;
struct module;

struct intr_type;
struct intr_type_array;
struct intr_type_char;
struct intr_type_class;
struct intr_type_compat;
struct intr_type_compound;
struct intr_type_fixed_number;
struct intr_type_float;
struct intr_type_function;
struct intr_type_integer;
struct intr_type_number;
struct intr_type_rational;
struct intr_type_tuple;
struct intr_type_type;
struct intr_type_value_list;
struct intr_type_wrap;

class source;
class type_converter;
struct cvt_expression;

class module_loader;
class serial_in;
class serial_out;
struct serial_resolver;
class type_manager;

} //eon leaf

namespace util {
	struct validation_context;
}

#include "lang/common.hpp"

#endif