#ifndef LANG_NOOP_STATEMENT_HPP
#define LANG_NOOP_STATEMENT_HPP

#include "statement.hpp"

namespace leaf {

struct noop_statement : public statement {
	typedef statement super;
	
	virtual statement_form_t statement_form() const {
		return sf_noop_statement;
	}
	
	STATEMENT_PRE_CLONE(noop_statement)
	STATEMENT_SERIAL()
protected:
	void pre_copy( noop_statement const & o );
	
	void write_impl( serial_out & so ) const;
	void read_impl( serial_in & so );
};

} //eon leaf

#endif