#ifndef LEAF_RETURN_STATEMENT_HPP
#define LEAF_RETURN_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

struct statement_block;

/**
	Defer statements are run at the end of a block. These are run in normal and error flow.
*/
struct return_statement : public statement
{
	typedef statement super;
	
	//an optional value which is being returned (may be null)
	shared_ptr<expression> value;
	
	virtual statement_form_t statement_form() const { 
		return sf_return_statement; 
	}
	virtual int get_flow() const { 
		return flow_return; 
	}
	
	STATEMENT_PRE_CLONE(return_statement);
	STATEMENT_SERIAL()
protected:
	void pre_copy( return_statement const & o );
	
	void write_impl( serial_out & so ) const;
	void read_impl( serial_in & so );
	
};

} //eon leaf

#endif