#ifndef STATEMENT_IMPORTER_HPP
#define STATEMENT_IMPORTER_HPP

#include "statement_visitor.hpp"
#include "expression_visitor.hpp"

namespace leaf
{

struct statement_importer : public expression_transformer, public stat_expr_transformer
{
	statement_importer( shared_ptr<scope> target_symbols )
		: expression_transformer(true)
		, stat_expr_transformer( static_cast<expression_transformer&>(*this) )
		, target_symbols( target_symbols )
	{ }
	
protected:
	shared_ptr<scope> target_symbols;
	
	shared_ptr<statement> istmt_init( shared_ptr<init_statement> in,
		shared_ptr<scope> sc );
	
	shared_ptr<expression> apply_symbol( shared_ptr<expr_symbol> in );
	shared_ptr<expression> apply_funccall( shared_ptr<expr_funccall> in );
	shared_ptr<expression> apply_value_list( shared_ptr<expr_value_list> in );
};

} //eon leaf

#endif