#ifndef LEAF_TYPE_MANAGER_HPP
#define LEAF_TYPE_MANAGER_HPP

#include "fwd.hpp"

namespace leaf {

/**
	Centralized access to standard types and behaviours during the typing process.
*/
class type_manager {

public:
	type_manager( shared_ptr<scope> root );
	
	shared_ptr<intr_type_tuple const> get_integer_range();
	shared_ptr<intr_type_array const> get_primordial_array();
	shared_ptr<intr_type_type const> get_primordial_type();
	shared_ptr<intr_type_class const> get_error_info();
	shared_ptr<intr_type_compat const> get_string_tag();
	
private:
	shared_ptr<scope> root;
	shared_ptr<intr_type_tuple const> integer_range;
	shared_ptr<intr_type_array const> primordial_array, primordial_raw_array;
	shared_ptr<intr_type_type const> primordial_type;
	shared_ptr<intr_type_class const> error_info;
	shared_ptr<intr_type_compat const> string_tag;
};

} //eon leaf

#endif