#ifndef LEAF_LANG_TYPEDEF_STATEMENT_HPP
#define LEAF_LANG_TYPEDEF_STATEMENT_HPP

#include "statement.hpp"
#include "type.hpp"

#include <vector>

namespace leaf
{

/**
*/
struct typedef_statement : public statement
{
	typedef statement super;
	
	typedef_statement();
	
	statement_form_t statement_form() const { 
		return sf_typedef_statement; 
	}
	
	bool is_declarative() const { 
		return true; 
	}
	
	enum what_t {
		//new type is a prototype
		w_prototype  = 1,
		//a class type
		w_class,
		//a spec alias,
		w_alias,
		//a service type
		w_service,
	} what;
	
	std::string name;
	type_ref type;
	//for prototype and parametric classes
	shared_ptr<type_spec> spec_type;
	//for class
	shared_ptr<statement_block> class_block;
	
	//flagged for export
	bool is_export;
	//is an inherent type (used for type bootstrapping, not an official annotation)
	bool is_inherent;
	
	STATEMENT_PRE_CLONE(typedef_statement)
	
	//tracking bits (used by proc_typedef_statement)
	bool proc_scope_added;
	shared_ptr<intr_type_tuple> proc_tuple;
protected:
	void pre_copy( typedef_statement const & o );
};

} //eon leaf
#endif