#ifndef VAR_STATEMENT_HPP
#define VAR_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

struct expression;

struct var_statement : public statement
{
	typedef statement super;
	
	shared_ptr<declaration> decl;
	
	//the initial value, or mapped value
	shared_ptr<expression> value;
	//initializes the value of a reference rather than the reference itself
	bool init_refer_value;
	
	statement_form_t statement_form() const
	{ return sf_var_statement; }
	bool is_declarative() const
	{ return true; }

	var_statement( ) :
		init_refer_value( false ) {
	}
	
	void validate(util::validation_context & vctx) const;
	
	//set during symbol scanning
	shared_ptr<declaration> sref;
	
	STATEMENT_PRE_CLONE(var_statement);
	STATEMENT_SERIAL()
protected:
	void pre_copy( var_statement const & o );
	
	void write_impl( serial_out & so ) const;
	void read_impl( serial_in & so );
	
};

} //eon leaf

#endif
