#ifndef LEAF_PARSER_FWD
#define LEAF_PARSER_FWD

namespace leaf
{

struct node;

struct type_spec;

/**
	This is to treat type_spec as a distinct type during parsing, to prevent accidental assignment
	with incomplete processing.
*/
struct node_type_spec
{
	
	node_type_spec( shared_ptr<type_spec const> const & o ) :
		spec(o) { 
	}
	node_type_spec( shared_ptr<type_spec> const & o ) :
		spec(o) { 
	}
	node_type_spec() {
	}
	
	operator bool() const {
		return !!spec;
	}
	
	shared_ptr<type_spec const> parsed_type_spec() const {
		return spec;
	}
private:
	shared_ptr<type_spec const> spec;
};

}
#endif