#ifndef intr_type_PARSER_HPP
#define intr_type_PARSER_HPP

#include "source.hpp"
#include "../lang/fwd.hpp"
#include "fwd.hpp"

namespace leaf
{

struct intr_type_parser
{
	static node_type_spec parse( source & src );
	
	/**
		The inline notation follows a keyword like "new" and is terminated by the first
		open paren '(' character at the root level (this character is *not* consumed).
		As an exception, if the first character is a '(' then the closing ')' character ends the type.
	*/
	static node_type_spec parse_inline( source & src);
	static node_type_spec if_parse_inline( source & src );
	static node_type_spec parse_inline_param( source & src );
private:
	intr_type_parser();
	
	enum parse_flags_t 	{
		pf_inline = 1<<0,
		//a line end does not terminate this type
		pf_line_cont = 1<<1,
	};
	enum parse_tuple_flags_t {
		ptf_no_names = 1 << 0,
	};
	shared_ptr<type_spec> parse_tuple( source & src, src_symbol_t end, unsigned flags = 0 );
	void parse_signature( source & src, shared_ptr<type_spec> const & sig );
	shared_ptr<type_spec> parse_single( source & src, unsigned flags = 0, bool * empty = nullptr );
	
	void extend_with_tuple( shared_ptr<type_spec> vt, source & src, src_symbol_t end, unsigned flags = 0 );
};

} //eon leaf

#endif