#ifndef PLATFORM_PLATFORM_HPP
#define PLATFORM_PLATFORM_HPP

namespace platform
{

struct native_integer {
	int size;
};

struct native_float {
	int size;
	int precision; //0 = natural, -1 low, +1 high (could in theory be more range)
	int significand_size;
};

/*
	For simplicity and compiler effeciency the target platform is defined statically. This is generally
	okay, since for the eventual need to do cross-compilation simply a different exectuable is needed
	(which is common).
*/

} //eon platform

#include "gnu_linux_x86_64.hpp"

namespace platform 
{

int const native_integers_size = int(sizeof(native_integers)/sizeof(native_integer));
int const native_floats_size = int(sizeof(native_floats)/sizeof(native_float));

/**
	@return The native_float of this size, nullptr if it couldn't be found
*/
inline native_float const * if_get_float( int float_size ) {
	for( int i=0; i < native_floats_size; ++i ) {
		if( float_size == native_floats[i].size )
			return native_floats + i;
	}
	return nullptr;
}

inline native_float const * if_get_float_precision( int prec ) {
	for( int i=0; i < native_floats_size; ++i ) {
		if( prec == native_floats[i].precision )
			return native_floats + i;
	}
	return nullptr;
}

} //eon platform


#endif