#ifndef LEAF_RUNNER_EXPECTER_HPP
#define LEAF_RUNNER_EXPECTER_HPP

#include "runner/fwd.hpp"

struct expecter {
	/**
		Check the execution result against conditions.
		
		Returns if okay, throws on error.
	*/
	virtual void check_result( std::string const & actual, int return_value ) = 0;
	
	/**
		Check if the compile-time exception matches the expected conditions.
		
		Returns if the exception was properly caught, rethrows on unknown/mismatch.
	*/
	virtual void catch_compile_exception( recoverable_error & re ) const = 0;
	
	/**
		Check an abort message (indicates abort actually occurred).
		
		@return true if message handled, false if unknown error
	*/
	virtual bool catch_runtime_abort( std::string const & e ) const = 0;
};

#endif