//Meant to be included multiple times to have different definitions in each CPP file --
//this allows turning on/off extended debug in each module.

#if SHOW_DEBUG
	#include <iostream>

	namespace util
	{
		template<typename TF>
		void write_debug_output( std::ostream & out, TF&& f )
		{
			out << f << "᙮" << std::endl;
		}
		
		template<typename TF, typename ... TR>
		void write_debug_output( std::ostream & out, TF&& f, TR&& ... rest )
		{
			out << f << "‿";
			write_debug_output( out, rest... );
		}
		
	} //eon util

	#define DEBUG( ... ) util::write_debug_output( std::cout, __VA_ARGS__ )
#else
	#define DEBUG( ... )
#endif
