// Generate llvm IR
// clang -emit-llvm ll_struct.c -S -o /dev/tty
#include <stdio.h>
#include <stdlib.h>

typedef struct large
{
	int a;
	char b;
	float c;
	double d;
} large;

typedef struct small
{
	int a;
	char b;
} small;

typedef struct packed
{
	char a;
	int b;
} __attribute__((packed)) packed;

int main()
{
	large m;
	m.a = 5;
	m.b = 'q';
	return 0;
}

int take_struct_large( large a )
{
	return a.a + a.b;
}

large make_struct_large( int a, char b )
{
	large r;
	r.a = a;
	r.b = b;
	return r;
}

void check_struct_large()
{
	large q = make_struct_large( 1, 'a');
}

void copy_struct_large()
{
	large a;
	large b;
	a = b;
}

small make_struct_small( int a, char b )
{
	small r;
	r.a = a;
	r.b = b;
	return r;
}

large * mem_large()
{
	large * l = malloc(sizeof(large));
	l->a = 1;
	l->b = 2;
	l->c = 3;
	l->d = 4;
	return l;
}

large * mem_copy_large()
{
	large l;
	l.a = 1;
	l.b = 2;
	l.c = 3;
	l.d = 4;
	
	large * r = malloc(sizeof(large));
	*r = l;
	return r;
}

int call( int * a ) 
{	
	return *a;
}

int * get_packed( packed * p ) 
{
	int * a = &p->b;
	call(a);
	return a;
}

