#include <cstdint>

//these are pulled from the System V Application Binary Interface x86-64 Architecture Processort Supplement Draft Version 0.95 
//http://refspecs.linuxfoundation.org/

extern "C" {

typedef uint8_t* _Unwind_Ptr;

typedef enum {
	_URC_NO_REASON = 0,
	_URC_FOREIGN_EXCEPTION_CAUGHT = 1,
	_URC_FATAL_PHASE2_ERROR = 2,
	_URC_FATAL_PHASE1_ERROR = 3,
	_URC_NORMAL_STOP = 4,
	_URC_END_OF_STACK = 5,
	_URC_HANDLER_FOUND = 6,
	_URC_INSTALL_CONTEXT = 7,
	_URC_CONTINUE_UNWIND = 8
} _Unwind_Reason_Code;

typedef int _Unwind_Action;
const _Unwind_Action _UA_SEARCH_PHASE = 1;
const _Unwind_Action _UA_CLEANUP_PHASE = 2;
const _Unwind_Action _UA_HANDLER_FRAME = 4;
const _Unwind_Action _UA_FORCE_UNWIND = 8;
const _Unwind_Action _UA_END_OF_STACK = 16; //not in the ABI but commonly used ?

struct _Unwind_Exception;
typedef void (*_Unwind_Exception_Cleanup_Fn)	(_Unwind_Reason_Code reason,
	struct _Unwind_Exception *exc);
struct _Unwind_Exception {
	uint64_t exception_class;
	_Unwind_Exception_Cleanup_Fn exception_cleanup;
	uint64_t private_1;
	uint64_t private_2;
} __attribute__((__aligned__)); //LLVM says maxalign, docs say 8

struct _Unwind_Context;

_Unwind_Reason_Code _Unwind_RaiseException( struct _Unwind_Exception *exception_object );

typedef _Unwind_Reason_Code (*_Unwind_Stop_Fn)(int version,
	_Unwind_Action actions, uint64_t exceptionClass, struct _Unwind_Exception *exceptionObject,
	struct _Unwind_Context *context, void *stop_parameter );
	
_Unwind_Reason_Code _Unwind_ForcedUnwind( struct _Unwind_Exception *exception_object,
	_Unwind_Stop_Fn stop, void *stop_parameter );
	
void _Unwind_Resume(struct _Unwind_Exception *exception_object);
void _Unwind_DeleteException(struct _Unwind_Exception *exception_object);
uint64_t _Unwind_GetGR(struct _Unwind_Context *context, int index);
void _Unwind_SetGR(struct _Unwind_Context *context,int index,uint64_t new_value);
uint64_t _Unwind_GetIP(struct _Unwind_Context *context);
void _Unwind_SetIP(struct _Unwind_Context *context, uint64_t new_value);
_Unwind_Ptr _Unwind_GetLanguageSpecificData(struct _Unwind_Context *context);
uint64_t _Unwind_GetRegionStart(struct _Unwind_Context *context);
uint64_t _Unwind_GetCFA(struct _Unwind_Context *context);
_Unwind_Reason_Code (*__personality_routine)(int version,
	_Unwind_Action actions, uint64_t exceptionClass, struct _Unwind_Exception *exceptionObject,
	struct _Unwind_Context *context);
_Unwind_Ptr _Unwind_GetDataRelBase(struct _Unwind_Context * context);
_Unwind_Ptr _Unwind_GetTextRelBase(struct _Unwind_Context * context);

}
