#include "lang/assign_statement.hpp"
#include "lang/expression.hpp"
#include "lang/serial.hpp"

namespace leaf {

void assign_statement::pre_copy( assign_statement const & o ) {
	super::pre_copy(o);
	how = o.how;
	left = o.left->pre_clone();
	right = o.right->pre_clone();
}

void assign_statement::write_impl( serial_out & so ) const {
	so.write( how );
	so.write_ref( left );
	so.write_ref( right );
}

void assign_statement::read_impl( serial_in & so ) {
	so.read( how );
	left = so.read_expression_ref();
	right = so.read_expression_ref();
}

}