#include "lang/cerr.hpp"

namespace leaf
{

std::string cerr_base::explain_error() const
{
	std::string err;
	switch( error )
	{
		#define CERR_ENUM(t) \
			case cerr::t: err = #t; break;
		CERR_ENUMS
		#undef CERR_ENUM
	}
	if( err.empty() )
		err = "corrupt error";
		
	if( error_extra.size() ) {
		err += ": ";
		err += error_extra;
	}
	return err;
}

} //eon leaf