#include "lang/declaration.hpp"
#include "lang/type.hpp"
#include "lang/scope.hpp"
#include "lang/expression.hpp"

namespace leaf
{

void declaration::validate(util::validation_context & vctx) const {
	if( type.is_fixated() ) {
		type.validate(vctx);
	}
	STATE_CHECK(var_scope);
}

unsigned declaration::get_root_depth() const {
	PRE_CHECK(var_scope);
	return var_scope->get_level();
}

unsigned declaration::get_capture_level() const {
	if( !proximal_capture ) {
		return 0;
	}
	return 1 + proximal_capture->get_capture_level();
}

shared_ptr<expr_symbol> declaration::create_expr_symbol() {
	auto sym = make_shared<expr_symbol>();
	sym->symbol = symbol;
	sym->sref = shared_from_this();
	sym->type = type;
	return sym;
}


} //eon leaf