#include "lang/error_statement.hpp"
#include "lang/statement_block.hpp"
#include "lang/serial.hpp"

namespace leaf {

int error_statement::get_flow() const {
	int flow = flow_sequence;
	
	if (inner) {
		flow |= inner->get_flow() & ~(flow_resume | flow_fail);
	}
	
	return flow | error.on_error->get_flow();
}
	
void error_statement::pre_copy( error_statement const & o ) {
	super::pre_copy( o );
	if( o.inner ) {
		inner = o.inner->pre_clone();
	}
}
	
void error_statement::write_impl( serial_out & so ) const {
	super::write_impl( so );
	so.write_ref( inner );
}

void error_statement::read_impl( serial_in & si ) {
	super::read_impl(si);
	inner = si.read_statement_ref();
}

} //eon leaf