#include "lang/expression_statement.hpp"
#include "lang/expression.hpp"
#include "lang/serial.hpp"

namespace leaf {

void expression_statement::validate(util::validation_context & vctx) const {
	STATE_CHECK(expr);
	expr->validate(vctx);
	STATE_CHECK( expr->type.is_extr() );
	if( !ignore ) {
		STATE_CHECK( expr->type.extr().is<intr_type_value_list>()
			&& expr->type.extr().cast<intr_type_value_list>().sub.empty() );
	}
}

void expression_statement::pre_copy( expression_statement const & o) {
	expr = o.expr->pre_clone();
	ignore = o.ignore;
}

void expression_statement::write_impl( serial_out & so ) const {
	so.write_ref( expr );
	so.write( ignore );
}

void expression_statement::read_impl( serial_in & si ) {
	expr = si.read_expression_ref();
	si.read( ignore );
}

}