#include "lang/for_statement.hpp"
#include "lang/expression.hpp"
#include "lang/statement_block.hpp"
#include "lang/serial.hpp"

namespace leaf {

void for_statement::pre_copy( for_statement const & o ) {
	item = o.item;
	iterable = o.iterable->pre_clone();
	block = o.block->pre_clone();
}

void for_statement::write_impl( serial_out & so ) const {
	so.write(item);
	so.write_ref(iterable);
	block->write(so);
}

void for_statement::read_impl( serial_in & si ) {
	si.read(item);
	iterable = si.read_expression_ref();
	block = make_shared<statement_block>(si);
}

} //eon leaf
