#include "lang/module.hpp"
#include "lang/language.hpp"

namespace leaf {

void module::validate(util::validation_context & vctx) const {	
	if( vctx.cover(this) ) {
		return;
	}
	
	for( auto & b : blocks ) {
		b->validate(vctx);
	}
	
	STATE_CHECK( static_init_block );
	static_init_block->validate(vctx);
	
	for( auto & e : var_exports ) {
		e->validate(vctx);
	}
	
	STATE_CHECK( global );
	global->validate(vctx);
	
	STATE_CHECK( root );
	root->validate(vctx);
}

}