#include "lang/return_statement.hpp"
#include "lang/expression.hpp"
#include "lang/serial.hpp"

namespace leaf {

void return_statement::pre_copy( return_statement const & o ) {
	super::pre_copy(o);
	if( o.value ) {
		value = o.value->pre_clone();
	}
}

void return_statement::write_impl( serial_out & so ) const {
	so.write_ref(value);
}

void return_statement::read_impl( serial_in & si ) {
	value = si.read_expression_ref();
}

} //eon leaf