#include "lang/statement_importer.hpp"
#include "lang/language.hpp"

#define SHOW_DEBUG 0
#include "util/debug.hpp"

namespace leaf
{

shared_ptr<statement> statement_importer::istmt_init( shared_ptr<init_statement> in, 
	shared_ptr<scope> sc )
{
	DEBUG( "IMPORT INIT", in->sref.decl->symbol );
	in->sref = target_symbols->import( in->sref );
	//TODO: should this not be part of the generic visitor?
	if( in->code )
		in->code = apply_statement( in->code, sc );
	return in;
}

shared_ptr<expression> statement_importer::apply_symbol( shared_ptr<expr_symbol> in )
{
	DEBUG( "IMPORT SYMBOL", in->sref.decl->symbol );
	in->sref = target_symbols->import( in->sref );
	return in;
}

shared_ptr<expression> statement_importer::apply_funccall( shared_ptr<expr_funccall> in )
{
	in->func = apply_expression( in->func );
	in->args = apply_expression( in->args );
	if( in->context )
		in->context = apply_expression( in->context );
	return in;
}

shared_ptr<expression> statement_importer::apply_value_list( shared_ptr<expr_value_list> in ) {
	//TODO: ugh, this is exactly what I want to avoid with the importer!
	for( size_t i=0; i < in->sub.size(); ++i ) {
		in->sub[i].expr = apply_expression( in->sub[i].expr );
	}
	return in;
}

} //eon leaf