//included in ../type_identifier.cpp

resolve_t parameterize_type( context const & ctx, 
	intr_type const & param_type_, intr_type const & apply_, unsigned flags ) {
	
	auto ps = get_spec( ctx, param_type_ );
	if( !ps.okay() ) {
		return resolve_t(ps);
	}
	auto param_type = make_shared<type_spec>( *ps.result );
	
	auto apply = get_spec( ctx, apply_ );
	if( !apply.okay() )  {
		return resolve_t(apply);
	}
	
	param_map_t empty;
	auto c = expand_into( ctx, *param_type, *apply.result, empty, df_infer );
	if( !c.okay() ) {
		return resolve_t(c);
	}
	apply_infer(ctx, *param_type);
	return determine(ctx, param_type, flags);
}

resolve_t parameterize_type( context const & ctx, type_ref const & param_type_, 
	type_ref const & apply_, unsigned flags ) {
	
	//DEBUG( "PARAMETERIZE_TYPE", param_type_.contains_parametric(), param_type_.is_complete(),
	//	dump::get( param_type_ ), dump::get( apply_ ) );
		
	if( !param_type_.contains_parametric() || param_type_.is_complete() ) {
		return param_type_;
	}
	
	auto ps = get_spec( ctx, param_type_ );
	if( !ps.okay() ) {
		return resolve_t(ps);
	}
	//need to expand target since get_spec might have been from a unexpanded type_spec
	auto pes = expand( ctx, *ps.result );
	if( !pes.okay() ){
		return resolve_t(pes);
	}
	auto param_type = pes.result;
	
	auto apply = get_spec( ctx, apply_ );
	if( !apply.okay() )  {
		return resolve_t(apply);
	}
	
	param_map_t empty;
	//DEBUG("\n\nPRE-EXPAND", dump::get(param_type), dump::get(apply.result));
	auto c = expand_into( ctx, *param_type, *apply.result, empty, df_infer );
	if( !c.okay() ) {
		return resolve_t(c);
	}
	//DEBUG("POST-EXPAND", dump::get(param_type));
	apply_infer(ctx, *param_type);
	return determine(ctx, param_type, flags);
}
