#include "lang/typedef_statement.hpp"
#include "lang/statement_block.hpp"
#include "lang/type_spec.hpp"

namespace leaf {

typedef_statement::typedef_statement() {
	is_export = false;
	what = (what_t)0;
}

void typedef_statement::pre_copy( typedef_statement const & o ) {
	super::pre_copy(o);
	what = o.what;
	name = o.name;
	is_export = o.is_export;
	if( o.spec_type ) {
		spec_type = make_shared<type_spec>(*o.spec_type);
	} else {
		spec_type.reset();
	}
	
	if( o.class_block ) {
		class_block = o.class_block->pre_clone();
	} else {
		class_block.reset();
	}
}

} //eon leaf