#include "lang/var_statement.hpp"
#include "lang/declaration.hpp"
#include "lang/expression.hpp"
#include "lang/serial.hpp"

namespace leaf
{

void var_statement::validate(util::validation_context & vctx) const {
	statement::validate(vctx);
	STATE_CHECK(decl);
}

void var_statement::pre_copy( var_statement const & o ) {
	super::pre_copy(o);
	decl = declaration::create(*o.decl);
	if( o.value ) {
		value = o.value->pre_clone();
	}
	init_refer_value = o.init_refer_value;
}

void var_statement::write_impl( serial_out & so ) const {
	so.write_ref( decl );
	so.write_ref( value );
	so.write( init_refer_value );
	so.write_ref( sref );
}

void var_statement::read_impl( serial_in & si ) {
	decl = si.read_declaration_ref();
	value = si.read_expression_ref();
	si.read( init_refer_value );
	sref = si.read_declaration_ref();
}

}//eon leaf