#include <boost/test/unit_test.hpp>

#include "util/object_holder.hpp"


BOOST_AUTO_TEST_SUITE( object_holder_test )

struct inc {
	int & ref;
	int amount;
	
	inc( int & ref, int amount ) 
		: ref(ref)
		, amount(amount)
	{ }
	
	~inc()
	{
		ref += amount;
	}
};

BOOST_AUTO_TEST_CASE( basic )
{
	util::object_holder oh;
	
	int count = 0;
	auto a = oh.make<inc>( count, 1 );
	BOOST_CHECK_EQUAL( &count, &a->ref );
	BOOST_CHECK_EQUAL( 1, a->amount );
	
	oh.make<inc>( count, 10 );
	oh.make<inc>( count, 100 );
	oh.make<inc>( count, 1000 );
	
	oh.clear();
	BOOST_CHECK_EQUAL( 1111, count );
}

BOOST_AUTO_TEST_SUITE_END()
