#include <boost/test/unit_test.hpp>

#include "parser/source.hpp"

using namespace leaf;

BOOST_AUTO_TEST_SUITE( source_suite )

BOOST_AUTO_TEST_CASE( match )
{
	char const * code = "some\n\tvalue";
	auto s = source::create( code, strlen(code) );
	auto & src = *s;
 
	boost::regex re_a( "s.mer" );
	BOOST_CHECK( !src.match( re_a ) );
	boost::regex re_b( "s.me" );
	BOOST_CHECK( src.match( re_b ) );
	BOOST_CHECK_EQUAL( "some", src.cur_match() );
	BOOST_CHECK_EQUAL( 5, src.cur_column() );
	BOOST_CHECK_EQUAL( 1, src.cur_line() );

	src.skip_space();
	src.next(); //skip line-feed
	src.skip_space();
	boost::regex re_c( "v(.*)e" );
	BOOST_CHECK( src.match( re_c ) );
	BOOST_CHECK_EQUAL( "alu", src.cur_match(1) );
	BOOST_CHECK_EQUAL( 10, src.cur_column() );
	BOOST_CHECK_EQUAL( 2, src.cur_line() );
}

BOOST_AUTO_TEST_SUITE_END()
