#include "util/file.hpp"

#include <fstream>
#include <stdexcept>

namespace util
{

std::string load_file( std::string const & name )
{
	std::string ret;
	std::ifstream in( name, std::ios::binary );
	if( !in )
		throw std::runtime_error( std::string("Cannot open: ") + name );

	int const BUF_SIZE = 4096;
	char buf[BUF_SIZE];
	while( in )
	{
		in.read( buf, BUF_SIZE );
		ret.append( buf, in.gcount() );
	}

	return ret;
}

} //eon util
